﻿using System;
using System.IO;
using System.Net.Mail;
using System.Reflection;

namespace TestProject
{
    /// <summary>
    /// 메일 메시지 확장
    /// </summary>
    public static class MailMessageExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 저장하기 - Save(mailMessage, filePath)

        /// <summary>
        /// 저장하기
        /// </summary>
        /// <param name="mailMessage">메일 메시지</param>
        /// <param name="filePath">파일 경로</param>
        public static void Save(this MailMessage mailMessage, string filePath)
        {
            Assembly assembly = typeof(SmtpClient).Assembly;

            Type mailWriterType = assembly.GetType("System.Net.Mail.MailWriter");

            using(FileStream fileStream = new FileStream(filePath, FileMode.Create))
            {
                ConstructorInfo mailWriterContructor = mailWriterType.GetConstructor
                (
                    BindingFlags.Instance | BindingFlags.NonPublic,
                    null,
                    new Type[] { typeof(Stream) }, 
                    null
                );

                object mailWriter = mailWriterContructor.Invoke(new object[] { fileStream });

                MethodInfo sendMethodInfo = typeof(MailMessage).GetMethod
                (
                    "Send",
                    BindingFlags.Instance | BindingFlags.NonPublic
                );

                sendMethodInfo.Invoke
                (
                    mailMessage,
                    BindingFlags.Instance | BindingFlags.NonPublic,
                    null,
                    new object[] { mailWriter, true },
                    null
                );

                MethodInfo closeMethodInfo = mailWriter.GetType().GetMethod
                (
                    "Close",
                    BindingFlags.Instance | BindingFlags.NonPublic
                );

                closeMethodInfo.Invoke
                (
                    mailWriter,
                    BindingFlags.Instance | BindingFlags.NonPublic,
                    null,
                    new object[] { },
                    null
                );
            }
        }

        #endregion
    }
}